{
===============================================================================
  Copyright (©) 2007. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 
  Versión actual: 1.0.0
  Fecha versión actual: 
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit uBizFabricantes;

interface

uses
  uDAInterfaces, uDADataTable, uDBSelectionListUtils, schFabricantesClient_Intf;

const
  BIZ_CLIENT_Fabricante = 'Client.Fabricante';

type
  IBizFabricante = interface(IFabricantes)
  ['{A82736D7-55AC-475F-8B08-98832EB6A1B1}']
    function EsNuevo : Boolean;
    
  	// Descomentar esto si hay clases detalles
    // procedure SetDetalles(AValue : IBizDetalles);
    // function GetDetalles : IBizDetalles;
    // property Detalles : IBizDetalles read GetDetalles write SetDetalles;  
  end;

  TBizFabricante = class(TFabricantesDataTableRules, IBizFabricante, ISeleccionable)
  protected
  	FSeleccionableInterface : ISeleccionable;
  	
  	// Descomentar esto si hay clases detalles
    // FDetalles : IBizDetalles;
    // FDetallesLink : TDADataSource;
    // procedure SetDetalles(AValue : IBizDetalles);
    // function GetDetalles : IBizDetalles;

    procedure OnNewRecord(Sender: TDADataTable); override;
    procedure AfterOpen(Sender: TDADataTable); override;
  public
    procedure IniciarValoresFabricanteNuevo;
    function EsNuevo : Boolean;
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

    property SeleccionableInterface : ISeleccionable 
    					read FSeleccionableInterface
    					write FSeleccionableInterface 
    					implements ISeleccionable;
    
  	// Descomentar esto si hay clases detalles
    // property Detalles : IBizDetalles read GetDetalles write SetDetalles;    
  end;

implementation

{ TBizFabricante }

uses
  SysUtils, uDataTableUtils;

// Descomentar esto si hay clases detalles
// function TBizFabricante.GetDetalles: IBizDetalles;
// begin
//   Result := FDetalles;
// end;

// Descomentar esto si hay clases detalles
// procedure TBizFabricante.SetDetalles(AValue: IBizDetalles);
// begin
//   FDetalles := AValue;
//   EnlazarMaestroDetalle(FDetallesLink, FDetalles);
// end;

procedure TBizFabricante.AfterOpen(Sender: TDADataTable);
begin
  inherited;
  DataTable.Sort([fld_FabricantesDESCRIPCION], [sdAscending]);
end;

constructor TBizFabricante.Create(aDataTable: TDADataTable);
begin
  inherited;
  // Descomentar esto si hay clases detalles
  // FDetallesLink := TDADataSource.Create(NIL);
  // FDetallesLink.DataTable := aDataTable;  
  
	FSeleccionableInterface := TSeleccionable.Create(aDataTable);  
end;

destructor TBizFabricante.Destroy;
begin
	// Descomentar esto si hay clases detalles
  // FDetalles := NIL;
  // FreeAndNIL(FDetallesLink);	
  
  FSeleccionableInterface := NIL;
  inherited;
end;

function TBizFabricante.EsNuevo: Boolean;
begin
  Result := (ID < 0);
end;

procedure TBizFabricante.IniciarValoresFabricanteNuevo;
begin
  //
end;

procedure TBizFabricante.OnNewRecord(Sender: TDADataTable);
begin
  inherited;
  ID := GetRecNo; // -1, -2, -3...
  IniciarValoresFabricanteNuevo;
end;

initialization
  RegisterDataTableRules(BIZ_CLIENT_Fabricante, TBizFabricante);

finalization

end.

